/*
 * sbrk.S
 * Updated file for V2.2.0 release only.
 */

        .section .text

        .global _sbrk
_sbrk:

        lda     $r1,__heap_ptr
        bins.l  $r1,$r1,(1 << 5) | 23    # NEW for v2.2.0: clear bit 23 to remove the 0x80 prefix
        add     $r2,$r1,$r0

        sub     $r3,$sp,1000  # stack safety area, 1000 bytes
        cmp     $r2,$r3
        jmpc    lt,sbrkok
        # No room, so fail by returning -1
        ldk     $r0,-1
        return
sbrkok:
        sta     __heap_ptr,$r2
        move    $r0,$r1
        return

        .section .data
__heap_ptr:
        .long _end
